import express from 'express';
import path from 'path'
import fs from 'fs/promises'
import Jimp from 'jimp'
import crypto from 'crypto'

const app = express()

app.use('/assets',express.static('images'))
/* eslint-disable max-depth */
/* eslint-disable complexity */
app.listen(3000, () => {
	console.log('The application is listening on port 3000!');
})
/**
 *
 *
 * @param path the folder to search
 *
 * @return the list of files included in this folder/subfolders
 */
async function filesList(Path: string): Promise<string[]> {
	const files: Array<string> = []
	const subFolders = await fs.readdir(Path)

	for await (const subFolder of subFolders){
		const stats = await fs.stat(Path + '/' + subFolder)
		if (stats.isDirectory()) {
			files.push(...await filesList(Path + '/' + subFolder))

		} else {
			files.push(Path + '/' + subFolder)
		}
	}
	return files
}

app.get('/program', (_req, res) => {

	(async (dirPath: string) => {
		const files = await filesList(dirPath)
		console.log(files)
		// Filtre
		const data = (await fs.readFile('./output.json')).toString('utf8')

		let json: Record<string, string> = {}
		try{
			json = JSON.parse(data)

		}catch{
			console.log('handeling...')
		}

		for await (const file of files) {

			const bFile = path.basename(file)
			const pName = path.dirname(file)
			const hash = crypto.createHash('sha256')
			hash.setEncoding('hex')
			const readI = await fs.readFile(`${file}`)
			hash.write(readI)
			hash.end()
			const sha256sum = hash.read()
			console.log('bfile = ' + bFile)

			if (bFile.startsWith('.')) {
				continue
			}else if (json[file] === sha256sum){
				console.log('This picture has already been turned to sepia')
				continue
			}

			// Modification des données
			json[file] = sha256sum

			// Ré-écriture dans le fichier output
			await fs.writeFile('output.json', JSON.stringify(json))

			try{
				const image = await Jimp.read(readI)
				image.sepia()
				console.log(bFile)
				const newFileName = pName + '/.' + bFile
				console.log('newfilename:' + newFileName)
				// save image with new file name
				await image.writeAsync(`${newFileName}`)
				console.log('Images have been inverted and rename ' + '.' + file)
			}catch (err){
				console.log('this file is not an image')
			}
		}
		res.send('Pictures transformed')
		res.end()

	})('./images')
})
{
	app.get('/', async (_req, res) => {
		const list = await filesList('./content')
		const item = list[Math.floor(Math.random()*((list)).length)]
		const itemB =await fs.readFile(item)
		res.send(itemB)
		console.log(item)

	})
}

